//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * サウンド能力実装
 * @author Junpee
 */

#include "LampBasic.h"
#include "Sound/System/SoundCapacity.h"
#include "Sound/System/SoundDefinition.h"

namespace Lamp{

//------------------------------------------------------------------------------
// コンストラクタ
SoundCapacity::SoundCapacity() : directSound_(NULL){
}
//------------------------------------------------------------------------------
// デストラクタ
SoundCapacity::~SoundCapacity(){
}
//------------------------------------------------------------------------------
// 初期化
bool SoundCapacity::initialize(DirectSound* directSound){
	directSound_ = directSound;
	if(!refresh()){ return false; }
	// 能力に適合しなくてもDirectSoundが対応してくれる？
//	if(!checkCapacity()){ return false; }
	return true;
}
//------------------------------------------------------------------------------
// 更新
bool SoundCapacity::refresh(){
	capacity_.dwSize = sizeof(DSCAPS);
	if(DirectXFailed(directSound_->GetCaps(&capacity_))){
		ErrorOut("SoundCapacity::refresh() サウンド能力の取得に失敗しました");
		return false;
	}
	return true;
}
//------------------------------------------------------------------------------
// 能力チェック
bool SoundCapacity::checkCapacity(){
	// プライマリバッファのチェック
	if((SoundDefinition::primaryBufferBit == 8) &&
		(!isSupported8bitPrimaryBuffer())){
		ErrorOut("SoundCapacity::checkCapacity() "
			"8bitプライマリバッファがサポートされていません");
		return false;
	}
	if((SoundDefinition::primaryBufferBit == 16) &&
		(!isSupported16bitPrimaryBuffer())){
		ErrorOut("SoundCapacity::checkCapacity() "
			"16bitプライマリバッファがサポートされていません");
		return false;
	}
	if(SoundDefinition::primaryBufferStereo){
		if(!isSupportedStereoPrimaryBuffer()){
			ErrorOut("SoundCapacity::checkCapacity() "
				"ステレオプライマリバッファがサポートされていません");
			return false;
		}
	}else{
		if(!isSupportedMonauralPrimaryBuffer()){
			ErrorOut("SoundCapacity::checkCapacity() "
				"モノラルプライマリバッファがサポートされていません");
			return false;
		}
	}
	// セカンダリバッファのチェック
	if((SoundDefinition::secondaryBufferBit == 8) &&
		(!isSupported8bitSecondaryBuffer())){
		ErrorOut("SoundCapacity::checkCapacity() "
			"8bitセカンダリバッファがサポートされていません");
		return false;
	}
	if((SoundDefinition::secondaryBufferBit == 16) &&
		(!isSupported16bitSecondaryBuffer())){
		ErrorOut("SoundCapacity::checkCapacity() "
			"16bitセカンダリバッファがサポートされていません");
		return false;
	}
	if(!isSupportedStereoSecondaryBuffer()){
		ErrorOut("SoundCapacity::checkCapacity() "
			"ステレオセカンダリバッファがサポートされていません");
		return false;
	}
	if(!isSupportedMonauralSecondaryBuffer()){
		ErrorOut("SoundCapacity::checkCapacity() "
			"モノラルセカンダリバッファがサポートされていません");
		return false;
	}
	if(SoundDefinition::secondaryBufferRate > getMaxSecondarySampleRate()){
		ErrorOut("SoundCapacity::checkCapacity() "
			"セカンダリバッファのサンプリングレートが大きすぎます");
		return false;
	}
	if(SoundDefinition::secondaryBufferRate < getMinSecondarySampleRate()){
		ErrorOut("SoundCapacity::checkCapacity() "
			"セカンダリバッファのサンプリングレートが小さすぎます");
		return false;
	}
	return true;
}
//------------------------------------------------------------------------------
// 文字列への変換
String SoundCapacity::toString() const{
	String result, temp;
	result += "Microsoft認定ドライバ      " +
		getBoolString(isCertifiedDriver()) + "\n";
	result += "連続的な周波数設定         " +
		getBoolString(isSupportedContinuousRate()) + "\n";
	result += "エミュレートドライバ       " +
		getBoolString(isEmulatedDriver()) + "\n";
	result += "16bitプライマリバッファ    " +
		getBoolString(isSupported16bitPrimaryBuffer()) + "\n";
	result += "8bitプライマリバッファ     " +
		getBoolString(isSupported8bitPrimaryBuffer()) + "\n";
	result += "モノラルプライマリバッファ " +
		getBoolString(isSupportedMonauralPrimaryBuffer()) + "\n";
	result += "ステレオプライマリバッファ " +
		getBoolString(isSupportedStereoPrimaryBuffer()) + "\n";
	result += "16bitセカンダリバッファ    " +
		getBoolString(isSupported16bitSecondaryBuffer()) + "\n";
	result += "8bitセカンダリバッファ     " +
		getBoolString(isSupported8bitSecondaryBuffer()) + "\n";
	result += "モノラルセカンダリバッファ " +
		getBoolString(isSupportedMonauralSecondaryBuffer()) + "\n";
	result += "ステレオセカンダリバッファ " +
		getBoolString(isSupportedStereoSecondaryBuffer()) + "\n";

	temp.format("セカンダリ最大サンプリングレート %5uHz\n",
		getMaxSecondarySampleRate());
	result += temp;
	temp.format("セカンダリ最小サンプリングレート %5uHz\n",
		getMinSecondarySampleRate());
	result += temp;

	return result;
}
//------------------------------------------------------------------------------
} // End of namespace Lamp
//------------------------------------------------------------------------------
